#!/usr/local/bin/perl

# valid referers
@referers = ('.*order4\.html');

# required fields
#@required = ("shipping_region", "shipping_method", "tax_area");

&check_referer;
&parse_form;
&check_required;
&print_html;

sub print_html {
	print "Content-type: text/html\n\n";

	print "<head>\n";
	print "<script language=\"JavaScript\">\n";
	print "function odd(n) {\n";
	print "if(n & 0x0001) return(1);\n";
	print "	else return(0);\n";
	print "}	\n";
	print "\n";
	print "function validate_credit_card(num) {\n";
	print "	var s=new String(num);\n";
	print "	var r=new String();\n";
	print "	for(var i=0;i<s.length;i++) {\n";
	print "		if((!isNaN(s.charAt(i))) && (s.charAt(i)!=\" \"))\n";
	print "			r+=s.charAt(i);\n";
	print "	}\n";
	print "	num = r;\n";
	print "	var i,len,x=0,y=0,v=0;\n";
	print "	var s=new String(num);\n";
	print "	if(s.length<12) v=0;\n";
	print "	else {\n";
	print "		len=s.length;\n";
	print "		if(odd(len)) {\n";
	print "			for(i=(len-2);i>=0;--i) {\n";
	print "				if(odd(i)) y=((s.charAt(i)-'0')*2);\n";
	print "				else y=(s.charAt(i)-'0');\n";
	print "				if(y>=10) y=((y-10)+1);\n";
	print "				x+=y;\n";
	print "			}\n";
	print "		}\n";
	print "		else {\n";
	print "			for(i=(len-2);i>=0;--i) {\n";
	print "				if(odd(i)) y=(s.charAt(i)-'0');\n";
	print "				else y=((s.charAt(i)-'0')*2);\n";
	print "				if(y>=10) y=((y-10)+1);\n";
	print "				x+=y;\n";
	print "			}\n";
	print "		}\n";
	print "		x=(10-(x%10));\n";
	print "		if(x==10) x=0;\n";
	print "		if(x==(s.charAt(s.length-1)-'0')) v=s.charAt(0);\n";
	print "		else v=0;\n";
	print "	}\n";
	print "	return(parseInt(v));\n";
	print "}	\n";
	print "function validate() {\n";
	print "	var error_string = \"$FORM{'ln_error_fields'}\\n\";\n";
	print "	var error_flag = false;\n";
	print "	var f = document.order_form;\n";
	print "	if(f.card_type.selectedIndex == 0) {\n";
	print "		error_flag = true;\n";
	print "		error_string += \"$FORM{'ln_payment_method'}\\n\";\n";
	print "	}\n";
	print "	var cc_type = f.card_type.options[f.card_type.selectedIndex].value.toString();\n";
	print "	if((cc_type == \"American Express\") || (cc_type == \"Novus (Discover)\") || (cc_type == \"Visa\") || (cc_type == \"Mastercard\")) {\n";
	print "		if(f.card_name.value.toString().length == 0) {\n";
	print "			error_flag = true;\n";
	print "			error_string += \"$FORM{'ln_cc_name'}\\n\";\n";
	print "		}\n";
	print "		if(f.card_number.value.toString().length == 0) {\n";
	print "			error_flag = true;\n";
	print "			error_string += \"$FORM{'ln_cc_number'}\\n\";\n";
	print "		}\n";
	print "	}\n";
	print "	if(error_flag) {\n";
	print "		alert(error_string);\n";
	print "		return(false);\n";
	print "	} else {\n";
	print "     if((cc_type == \"American Express\") || (cc_type == \"Novus (Discover)\") || (cc_type == \"Visa\") || (cc_type == \"Mastercard\")) {\n";
	print "			if(!validate_credit_card(f.card_number.value.toString())) {\n";
	print "				alert(\"$FORM{'ln_error_cc_invalid'}\\n(\" + f.card_number.value.toString() + \")\");\n";
	print "				return(false);\n";
	print "			}\n";
	print "		}\n";
	print "		return(true);\n";
	print "	}\n";
	print "}\n";
	print "</script>\n</head>\n";
	print "<body";
	&body_attributes;
	print ">\n";
	print "<form name=\"order_form\" method=\"POST\" action=\"shopwizard_email.cgi\" onSubmit=\"return(validate());\">\n";
	print "<center><img src=\"lockssl-on.gif\"></center><br>\n";
	print "<center><p><b>$FORM{'ln_fill_in_order'}</b></p></center>\n";
	print "<center>\n";
	print "<table border=\"3\" cellpadding=\"2\" width=\"90%\" bgcolor=\"$FORM{'doc_table_bgcolor'}\">\n";
	print "<tr><td>$FORM{'ln_payment_method'}:</td>\n";
	print "<td><select name=\"card_type\"><option value=\"\" selected>$FORM{'ln_cc_type'}\n";
	@payment_methods = split(/\|/, $FORM{'payment_methods'});
	foreach $method (@payment_methods) {
		print "<option value=\"$method\">$method\n";
	}
	print "</select></td></tr>";
	print "<tr bgcolor=\"$FORM{'doc_table_headcolor'}\">\n<td colspan=\"2\">\n";
	print "<font size=+1>$FORM{'ln_cc_information'}</font>\n</td>\n";
	print "</tr><tr>\n";
	print "<td>$FORM{'ln_cc_name'}:</td>\n";
	print "<td><input type=\"text\" name=\"card_name\" size=\"30\" maxlength=\"30\"></td>\n";
	print "</tr><tr>";
	print "<td>$FORM{'ln_cc_number'}:</td>\n";
	print "<td><input type=\"text\" name=\"card_number\" size=\"20\" maxlength=\"20\"></td>\n";
	print "</tr><tr>\n";
	print "<td>$FORM{'ln_cc_expiry'}:</td>\n";
	print "<td><select name=\"card_exp_month\">\n";
	print "<option value=\"01\" selected>(1) $FORM{ln_month_jan}\n";
	print "<option value=\"02\">(2) $FORM{ln_month_feb}\n";
	print "<option value=\"03\">(3) $FORM{ln_month_mar}\n";
	print "<option value=\"04\">(4) $FORM{ln_month_apr}\n";
	print "<option value=\"05\">(5) $FORM{ln_month_may}\n";
	print "<option value=\"06\">(6) $FORM{ln_month_jun}\n";
	print "<option value=\"07\">(7) $FORM{ln_month_jul}\n";
	print "<option value=\"08\">(8) $FORM{ln_month_aug}\n";
	print "<option value=\"09\">(9) $FORM{ln_month_sep}\n";
	print "<option value=\"10\">(10) $FORM{ln_month_oct}\n";
	print "<option value=\"11\">(11) $FORM{ln_month_nov}\n";
	print "<option value=\"12\">(12) $FORM{ln_month_dec}\n";
	print "</select>\n<select name=\"card_exp_year\">\n";
	print "<option value=\"1998\" selected>1998\n";
	print "<option value=\"1999\">1999\n";
	print "<option value=\"2000\">2000\n";
	print "<option value=\"2001\">2001\n";
	print "<option value=\"2002\">2002\n";
	print "<option value=\"2003\">2003\n";
	print "<option value=\"2004\">2004\n";
	print "<option value=\"2005\">2005\n";
	print "</select>";
	print "</td></tr>\n</table>\n</center>";

	print "<center><p><input type=\"reset\" value=\"$FORM{'ln_clear'}\">\n";
	print "<input type=\"submit\" value=\"$FORM{'ln_next'}\">\n";

	foreach $key (keys %FORM) {
		print "<input type=\"hidden\" name=\"$key\" value=\"$FORM{$key}\">\n";
	}
	foreach $key (keys %CONFIG) {
		print "<input type=\"hidden\" name=\"$key\" value=\"$CONFIG{$key}\">\n";
	}

	print "</form>\n";
	print "</body>\n</html>";
}

sub check_referer {
	if ($ENV{'HTTP_REFERER'}) {
		foreach $referer (@referers) {
			if ($ENV{'HTTP_REFERER'} =~ /$referer/i) {
				$referer_ok = '1';
				last;
			}
		}
	} else {
		$referer_ok = '1';
	}

	if ($referer_ok != 1) {
		&error('bad_referer');
	}
}

sub check_required {
	foreach $require (@required) {
		if ($require eq 'bgcolor' ||
			$require eq 'background' ||
			$require eq 'text_color' ||
			$require eq 'link_color' ||
			$require eq 'alink_color' ||
			$require eq 'vlink_color') {
			if (!($CONFIG{$require}) || $CONFIG{$require} eq ' ') {
				push(@ERROR, $require);
			}
		} elsif (!($FORM{$require}) || $FORM{$require} eq ' ') {
			push(@ERROR, $require);
		}
	}
	if (@ERROR) {
		&error('missing_fields', @ERROR);
	}
}

sub parse_form {

	if ($ENV{'REQUEST_METHOD'} =~ 'GET') {
		@pairs = split(/&/, $ENV{'QUERY_STRING'});		# Split the name-value pairs
	} elsif ($ENV{'REQUEST_METHOD'} =~ 'POST') {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});	# Get the input
		@pairs = split(/&/, $buffer);					# Split the name-value pairs
	} else {
		&error('request_method');
	}

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);			# Split pair into name and value

		$name =~ tr/+/ /;								# un-URL-encode the name
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;								# un-URL-encode the value
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		$value =~ s/<!--(.|\n)*-->//g;					# remove possible SSI directives from value

		if ($name eq 'bgcolor' ||
			$name eq 'background' ||
			$name eq 'text_color' ||
			$name eq 'link_color' ||
			$name eq 'alink_color' ||
			$name eq 'vlink_color' && ($value)) {
			$CONFIG{$name} = $value;
		} else {
			if ($FORM{$name} && ($value)) {
				$FORM{$name} = "$FORM{$name}, $value";
			} elsif ($value) {
				$FORM{$name} = $value;
			}
		}
	}
}

sub error {
	($error, @error_fields) = @_;

	print "Content-type: text/html\n\n";
	print "<html>\n<body";
	&body_attributes;
	print ">\n";

	if ($error eq 'bad_referer') {
		print "<center>\n<h1>Bad Referrer - Access Denied</h1>\n</center>\n";
		print "The form that is trying to use this CGI application\n";
		print "resides at: $ENV{'HTTP_REFERER'}, which is not allowed access.\n";
	} elsif ($error eq 'request_method') {
		print "<center>\n<h1>Error: Request Method</h1>\n</center>\n";
		print "The Request Method of the submitted form did not match\n";
		print "either GET or POST.<p>\n";
	} elsif ($error eq 'missing_fields') {
		print "<center>\n<h1>Error: Missing Fields</h1>\n</center>\n";
		print "The following fields require values:<p>\n";
		print "<ul>\n";
		foreach $missing_field (@error_fields) {
			print "<li>$missing_field\n";
		}
		print "</ul>\n";
	}

	print "<p><hr size=\"2\"></p>\n";
	print "<center><a href=\"$ENV{'HTTP_REFERER'}\">Go back</a>\n";
	print "</body>\n</html>\n";

	exit;
}

sub body_attributes {
	if ($CONFIG{'bgcolor'}) {
		print " bgcolor=\"$CONFIG{'bgcolor'}\"";
	}
	if ($CONFIG{'background'} =~ /http\:\/\/.*\..*/) {
		print " background=\"$CONFIG{'background'}\"";
	}
	if ($CONFIG{'link_color'}) {
		print " link=\"$CONFIG{'link_color'}\"";
	}
	if ($CONFIG{'vlink_color'}) {
		print " vlink=\"$CONFIG{'vlink_color'}\"";
	}
	if ($CONFIG{'alink_color'}) {
		print " alink=\"$CONFIG{'alink_color'}\"";
	}
	if ($CONFIG{'text_color'}) {
		print " text=\"$CONFIG{'text_color'}\"";
	}
}